#ifndef __KAN_ERRNO_H__
#define __KAN_ERRNO_H__

#include "kan/KAN.h"
#include <errno.h>

/**
 * @file kan_errno.h
 * @brief KAN Error Codes
 * @autor kauri
 */

typedef xui32   kan_stat_t;

/**
 * Return a human readable string describing the specified error.
 * @param   statCode The error code the get a string for.
 * @param   buf A buffer to hold the error string.
 * @param   bufSize Size of the buffer to hold the string.
 */
xstring     kan_strerror(kan_stat_t statCode, xstring buf, xui32 bufsize);

#define KAN_FROM_OS_ERROR(e) (e==0 ? KAN_SUCCESS : e + KAN_OS_START_SYSTEM)
#define KAN_TO_OS_ERROR(e) (e==0 ? KAN_SUCCESS : e - KAN_OS_START_SYSTEM)

#define KAN_OS_START_ERROR      (20000)
#define KAN_OS_ERRSPACE_SIZE    (50000)

#define KAN_SUCCESS 0

#define KAN_ENOMEM  ENOMEM

#define KAN_EOUTOFRANGE     1
#define KAN_EINVAL          EINVAL

#endif /* __KAN_ERRNO_H__ */
