####### XSP execution Makefile Common Part ############################

ARCH          	= $(PLATFORM)$(OSREL)$(GNUFLAG)$(CPU_TYPE)$(BITS_64)

TARGET			= $(BLKNAME).exe


####### MY_DFLAGS MY_IFLAGS  MY_LDFLAGS MY_LIBS  ######################
DFLAGS 			= $(XWARN) -D$(PLATFORM) -DERRDEBUG -D_REENTRANT $(DFLAGS_OPT) $(MY_DFLAGS)
IFLAGS 			= $(MY_IFLAGS) -I$(XSP_HOME)/include 

LDFLAGS 		= $(MY_LDFLAGS) -L$(XSP_HOME)/$(ARCH)/lib -L/usr/lib$(BITS_64)

BASE_LIBS		= -lBk -lUtil -lGen
LIBS 			= $(MY_LIBS) $(BASE_LIBS) $(SYSLIB)

CFLAGS 			= $(DFLAGS) $(IFLAGS)
CPPFLAGS 		= $(DFLAGS) $(IFLAGS)

OBJS            = $(SRCS:%.c=$(ARCH)/%.o)

VCONTROL 		= $(SRCS) $(HDRS) Makefile  
CLEARTOOL       = cleartool

CC				= $(COMPILER)

#YACC        	= yacc	    ... defined .cshrc.linux
#YFLAGS      	= -d   	    ... defined .cshrc.linux	
#LEX         	= lex	    ... defined .cshrc.linux	
#LEXFLAG       	= lexflag	... defined .cshrc.linux

INSTALL_XSP_BIN =   $(XSP_HOME)/$(ARCH)/bin
####### Make Target  Common Part #######################################
all : tbl $(ARCH)/$(TARGET)

tbl : $(TBLS)
	- $(XSP_HOME)/make/makeCsmTbl.sh $(TBLS)

$(ARCH)/%.o: %.c
	$(CC) $(DFLAGS)  \
		$(IFLAGS) \
		-c $< -o $@ \

#		-DXN_REL="\"@(#) $(XN_REL)\"" -DXN_DIR="\"`pwd`"\"  \
#		-DXN_VER="\"@(#) `$(CLEARTOOL) ls -s $<`\"" \


$(ARCH)/$(TARGET) : $(OBJS)
	$(CC) $(MY_LINK_OPT) -o $@ $(OBJS) \
		$(LDFLAGS) \
		$(LIBS) \


lex.yy.c    :$(LEXSRCS)
	$(LEX)  $(LEXFLAGS) $(LEXSRCS)

y.tab.c     :$(YACCSRCS)
	$(YACC) $(YFLAGS) $(YACCSRCS)



####### Make Target  Common Part ########################################

install : all
	cp -f $(ARCH)/$(TARGET) $(INSTALL_XSP_BIN)/$(TARGET) ; date

clean :
	\rm  -f $(OBJS) $(ARCH)/*.o $(ARCH)/$(TARGET) $(TARGET) lex.yy.c y.tab.[ch] Makefile.bak *~

cleanall :
	\rm  -f $(OBJS) $(ARCH)/*.o $(ARCH)/$(TARGET) $(TARGET) lex.yy.c y.tab.[ch] Makefile.bak *~

arch:
	- $(XCC_ATRIA)/util/mkobjdir $(ARCH)

depend :
	makedepend -p$(ARCH)/ -- $(CPPFLAGS) -- $(SRCS)
	- $(XCC_ATRIA)/util/mkobjdir $(ARCH)

################## Make package with vobs check-in ######################
v_install : all
	- cp -f $(ARCH)/$(TARGET) $(TARGET)
	- cp -f $(ARCH)/$(TARGET) $(INSTALL_XSP_BIN)/$(TARGET)
#	-$(XCC_ATRIA)/util/ctco $(INSTALL_XSP_BIN)/$(TARGET)
#	-$(XCC_ATRIA)/util/ctci -rm -from  $(ARCH)/$(TARGET)  $(INSTALL_XSP_BIN)/$(TARGET)
#	-cleartool unco -rm  $(INSTALL_XSP_BIN)/$(TARGET)

	
v_depend:
	- $(XCC_ATRIA)/util/ctco Makefile
	makedepend -p$(ARCH)/ -- $(CPPFLAGS) -- $(SRCS)
	- $(XCC_ATRIA)/util/ctci Makefile
	- cleartool unco -rm Makefile
	- $(XCC_ATRIA)/util/mkobjdir $(ARCH)



################## Make package with vobs check-in ######################
co:
	- cleartool co -nc $(VCONTROL)

unco:
	- cleartool unco -rm $(VCONTROL)

ci:
	- cleartool ci -nc $(VCONTROL)
	- cleartool unco -rm $(VCONTROL)

################## Make Label Config Part    ############################
lb: $(HDRS:.h=.zz)
	- $(XCC_ATRIA)/util/ctmklabel -replace DEV . $(VCONTROL)

tag:
	-ctags -t $(SRCS)

################## FLNT config Part #####################################
lnt:
	$(LNT) $(LNT_FILE) $(CFLAGS) $(SRCS)

include /usr/local/bin/xener.lnt.mk
# DO NOT DELETE THIS LINE -- make depend depends on it.
