#ifndef __IMEMPOOP_H__
#define __IMEMPOOP_H__

#include "kan/KAN.h"

__KAN_BEGIN_MEM_NAMSPACE


/* 
    - 메모리 풀은 메모리 노드로 구성된다. 
    - 사용자가 요청하는 메모리 사이즈에 적절한 노드를 할당한다. 
    - 네부 프로그멘테이션은 고려하지 않는다. 
    - 메모리 노드는 레퍼런스 카운트를 사용하여 가용 여부를 확인한다. 
    - 직렬화는 메모리 풀에 대해서 수행한다. 
        * 메모리 노드...
  */
typedef struct {
    struct MemNode_T    *next;
    xui32               idnex;  /** 메모리 노드 사이즈 인덱스 */
    xui32               reCnt;  /** 메모리 노드 참조 카운트 */
    void                *startAddr;  /** 노드에 할당된 메모리 시작 주소 */
    void                *availAddr;  /** 노드에 할당 가능한 메모리 주소 */
}MemNode_T;

/**
 */
class IMemPool 
{
public:
    void*   alloc(xsize_t size) = 0;
    void*   calloc(xsize_t size) = 0;
    void    setPoolTag(const xstring name) = 0;
};


__KAN_END_MEM_NAMESPACE

#endif  /* __IMEMPOOP_H__ */
