
#ifndef __IALLOCATOR_H__
#define __IALLOCATOR_H__

#include "kan/KAN.h"

template <typename T>
class IAllocator {
public:
    virtual size_t      max_size() = 0;
    virtual T*          allocate(size_t n) = 0;
    virtual T*          reallocate(T* ptr, size_t n) = 0;
    virtual void        deallocate(T* p) = 0;
};

#endif
