
#ifndef __NEW_ALLOCATOR_H__
#define __NEW_ALLOCATOR_H__

#include "kan/KAN.h"
#include "kan_IAllocator.h"

template <typename T>
class NewAllocator: public IAllocator<T> {
public:
    T*      allocate(size_t n) { 
        //return static_cast<T*>(::operator new(n*sizeof(T)));
        return static_cast<T*>(malloc(n*sizeof(T)));
    }
    T*      reallocate(T* ptr, size_t n) {
        return static_cast<T*>(realloc((void*)ptr, n*sizeof(T)));
    }
    void    deallocate(T* p) { ::operator delete(p); }
    size_t  max_size() { return (size_t(-1)/sizeof(T)); };
};

#endif
