#ifndef __MEMMNG_H__
#define __MEMMNG_H__

#include <sys/types.h> 

class IMemoryManager 
{
public:
    virtual void* allocate(size_t) = 0;
    virtual void   free(void*) = 0;
};

class MemoryManager: public IMemoryManager 
{ 
    struct FreeStore
    {
        FreeStore *next;
    }; 
    void expandPoolSize ();
    void cleanUp ();
    FreeStore* freeStoreHead;

public:
    MemoryManager () { 
        freeStoreHead = 0;
        expandPoolSize ();
    }
    virtual ~MemoryManager () { 
        cleanUp ();
    }
    virtual void* allocate(size_t);
    virtual void   free(void*);
};

#if 0
MemoryManager gMemoryManager;


void* operator new (size_t size) 
{
    return gMemoryManager.allocate(size);
}

void* operator new[ ] (size_t size)
{
    return  gMemoryManager.allocate(size);
}

void operator delete (void* pointerToDelete)
{
    gMemoryManager.free(pointerToDelete);
}

void operator delete[ ] (void* arrayToDelete)
{
    gMemoryManager.free(arrayToDelete);
}      
#endif

#endif
