#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "MemMng.h"

#define LNUM    30000
#define ASIZE   10000

MemoryManager gMemoryManager;

struct FreeStore 
{
    FreeStore* next;
};      

class Complex 
{
public:
    Complex (double a, double b): r (a), c (b) {}
    //inline void* operator new(size_t);
    //inline void   operator delete(void*);

private:
    double r; // Real Part
    double c; // Complex Part
};

int main(int argc, char* argv[]) 
{
    Complex* array[ASIZE];
    for (int i = 0;i  <  LNUM; i++) {
        for (int j = 0; j  <  ASIZE; j++) {
            array[j] = new Complex (i, j);
        }
#if 1
        for (int j = 0; j  <  ASIZE; j++) {
            delete array[j];
        }
#endif
    }
    return 0;
}      

#define POOLSIZE 8192

void MemoryManager::expandPoolSize ()
{
    size_t size = (sizeof(Complex) > sizeof(FreeStore*)) ?
        sizeof(Complex) : sizeof(FreeStore*);
    FreeStore* head = reinterpret_cast <FreeStore*> (new char[size]);
    if (head == NULL) {
        printf("~~~~~~~~~~~~~~~~~~~~~~\n");
        exit(0);
    }
    freeStoreHead = head;

    for (int i = 0; i < POOLSIZE; i++) {
        head->next = reinterpret_cast <FreeStore*> (new char [size]);
        if (head == NULL) {
            printf("~~~~~~~~~~~~~~~~~~~~~~\n");
            exit(0);
        }
        head = head->next;
    }

    head->next = 0;
}

void MemoryManager::cleanUp()
{
    FreeStore* nextPtr = freeStoreHead;
    for (; nextPtr; nextPtr = freeStoreHead) {
        freeStoreHead = freeStoreHead->next;
        delete [] nextPtr; // remember this was a char array
    }
}  


inline void* MemoryManager::allocate(size_t size)
{
    if (0 == freeStoreHead)
        expandPoolSize ();

    FreeStore* head = freeStoreHead;
    freeStoreHead = head->next;
    return head;
}

inline void MemoryManager::free(void* deleted)
{
    FreeStore* head = static_cast <FreeStore*> (deleted);
    head->next = freeStoreHead;
    freeStoreHead = head;
}

#if 0
void* Complex::operator new (size_t size) 
{
    return gMemoryManager.allocate(size);
}

void Complex::operator delete (void* pointerToDelete)
{
    gMemoryManager.free(pointerToDelete);
}  

#endif
