#ifndef __KAN_ICOLLECTION_H__
#define __KAN_ICOLLECTION_H__

#include "kan/KAN.h"
#include "kan/util.h"

//__KAN_BEGIN_UTIL_NASPACE
//namespace kan { namespace util {

template <typename T>
class ICollection: public IIterable<T> {
public:
    virtual boolean     add(T elem) = 0;
    virtual boolean     addAll(ICollection<T> collection) = 0;
    virtual boolean     remove(T elem) = 0;
    virtual boolean     removeAll(ICollection<T> collection) = 0;
    virtual boolean     size() = 0;
    virtual boolean     contains(T elem) = 0;
    virtual boolean     containsAll(ICollection<T> collection) = 0;
    virtual boolean     isEmpty(T elem) = 0;
    virtual IIterator<T>*   iterator() = 0;
};

//__KAN_END_UTIL_NAMESPACE

#endif  /* __KAN_ICOLLECTION_H__ */

