#ifndef __KAN_ABSTRACT_LIST_H__
#define  __KAN_ABSTRACT_LIST_H__

template <typename T>
class AbstractList: public AbstractCollection<T>, public IList<T> {
protected:
    xi32    modCount;
    AbstractList() {};

public:
    virtual xi32        indexOf(T e);
    virtual xi32        lastIndexOf(T e);

    virtual IList<T> *  subList(xi32 frontIdx, xi32 toIdx) = 0;

    virtual IComparator<T>*     comparator() = 0;
    virtual IIterator<T>*       iterator() = 0;
    virtual IListIterator<T>*   listIterator() = 0;
    virtual IListIterator<T>*   listIterator(xi32 idx) = 0;

};

template <typename T>
xi32 AbstractList<T>::indexOf(T e) 
{
    IListIterator<T> *litr = listIterator();
    IComparator<T>     *comp = comparator();

    while (litr->hasNext() == uTrue) {
        if (comp->compare(litr->next(), e) ==  0) {
            return litr->previousIndex();
        }
    }
    return -1;
}

template <typename T>
xi32 AbstractList<T>::lastIndexOf(T e) 
{
    IListIterator<T> *litr = listIterator();
    IComparator<T>     *comp = comparator();

    while (litr->hasPrevious() == uTrue) {
        if (comp->compare(litr->previous(), e) ==  0) {
            return litr->nextIndex();
        }
    }
    return -1;
}

#endif
