#ifndef __XEN_ARRAYLIST_H__
#define __XEN_ARRAYLIST_H__


#include "kan/util.h"
#include "new"

template <typename T>
//class ArrayList: public AbstractList<T> {
class ArrayList: public IList<T> {
private:
    T               *_array;
    xui32           _array_size;
    xui32           _size;
    IComparator<T>  *_comp;
    IAllocator<T>   *_alloc;
    
public:
    /* i think this contructors are is more simply using defautl parameters .... */
    /* but, i wnat to more indicatly codeing ..... */
    //ArrayList() {};
#if 1
    ArrayList();
    ArrayList(size_t initSize);
    ArrayList(size_t initSize, IComparator<T> *comp);
    ArrayList(size_t initSize, IComparator<T> *comp, IAllocator<T> *alloc);
#endif

    void trimToSize();
    void ensureCapacity(xui32 minCapacity);

    boolean     add(T e);
    boolean     add(xi32 idx, T e);
    boolean     remove(T e);
    boolean     remove(xi32 idx, T *e = NULL);
    boolean     contains(T e);

    T           get(xi32 idx);
    T           set(xi32 idx, T e);

    boolean     addAll(ICollection<T> *c);
    boolean     addAll(xi32 idx, ICollection<T> *c);
    boolean     removeAll(ICollection<T> *c);
    boolean     retainsAll(ICollection<T> *c);
    boolean     containsAll(ICollection<T> *c);

    void        clear();
    size_t      size();
    boolean     isEmpty(T e);

    xi32        indexOf(T e);
    xi32        lastIndexOf(T e);
    IList<T> *  subList(xi32 frontIdx, xi32 toIdx);

    IComparator<T>*     comparator();
    IIterator<T>*       iterator();
    IListIterator<T>*   listIterator();
    IListIterator<T>*   listIterator(xi32 idx);


};


#if 1
template <typename T>
ArrayList<T>::ArrayList() 
{
    size_t  size = 10;
    IComparator<T> *comp = new DefComprator<T>();
    IAllocator<T> *alloc = new NewAllocator<T>();
    ArrayList(size, comp, alloc);
}

template <typename T>
ArrayList<T>::ArrayList(size_t initSize) 
{
    IComparator<T> *comp = new DefComprator<T>();
    IAllocator<T> *alloc = new NewAllocator<T>();
    ArrayList(initSize, comp, alloc);
}

template <typename T>
ArrayList<T>::ArrayList(size_t initSize, IComparator<T> *comp) 
{
    IAllocator<T> *alloc = new NewAllocator<T>();
    ArrayList(initSize, comp, alloc);
}

template <typename T>
ArrayList<T>::ArrayList(size_t initSize, IComparator<T> *comp, IAllocator<T> *alloc) 
{
    size_t tmp = 10;
    if (initSize < 0 || comp == NULL || alloc == NULL) { 
        DMSG_ERR("invailed args....\n");
        throw this;
    } 
    if (initSize != 0) {
        tmp = initSize;
    }
    _comp = comp;
    _alloc = alloc;

    if (initSize == 0) return;

    _array = (T*)_alloc->allocate(initSize);
    if (_array == NULL) { 
        DMSG_ERR("no memory .... ");
        throw this;
    }

    _array_size = initSize;
    for (xui32 idx=0; idx < initSize; idx++) { 
        new (&_array[idx]) T;
    };
}
#endif

template <typename T>
void ArrayList<T>::trimToSize()
{
    //modCount++;
    xui32 oldCapacity = _array_size;
    if (_size < oldCapacity) { 
        //_array = Array.copyof(_array, size);
        /*  why do you define this fuction!!!! why???? */
    }
}

template <typename T>
void ArrayList<T>::ensureCapacity(xui32 minCapacity) 
{
    //modCount++;
    xui32 oldCapacity = _array_size;
    
    if (minCapacity > oldCapacity) {
        T* old_array = _array;
        xui32 newCapacity = (_array_size *3)/2 + 1;
        if (newCapacity < minCapacity) 
            newCapacity = minCapacity;
        _array = _alloc->realloc(_array, sizeof(T)*newCapacity);
        if (_array) {
            throw this;
        }
    }
}

template <typename T>
size_t ArrayList<T>::size()
{
    return _size;
}


template <typename T>
boolean ArrayList<T>::isEmpty(T e)
{
    return (_size == 0 ? uTrue : uFalse);
}

template <typename T>
boolean ArrayList<T>::add(T e)
{
    return uTrue;
}

template <typename T>
boolean ArrayList<T>::add(xi32 idx, T e)
{
    return uTrue;
}

template <typename T>
boolean ArrayList<T>::remove(T e)
{
    return uTrue;
}

#if 1
template <typename T>
boolean ArrayList<T>::remove(xi32 idx, T *e)
{
    return uTrue;
}
#endif

template <typename T>
boolean ArrayList<T>::contains(T e)
{
    return uTrue;
}



template <typename T>
T ArrayList<T>::get(xi32 idx)
{
    T tmp;
    return  tmp;
}

template <typename T>
T ArrayList<T>::set(xi32 idx, T e)
{
    T tmp;
    return  tmp;
}

template <typename T>
boolean ArrayList<T>::addAll(ICollection<T> *c)
{
    return uTrue;
}

template <typename T>
boolean ArrayList<T>::addAll(xi32 idx, ICollection<T> *c)
{
    return uTrue;
}

template <typename T>
boolean ArrayList<T>::removeAll(ICollection<T> *c)
{
    return uTrue;
}

template <typename T>
boolean ArrayList<T>::retainsAll(ICollection<T> *c)
{
    return uTrue;
}

template <typename T>
boolean ArrayList<T>::containsAll(ICollection<T> *c)
{
    return uTrue;
}

template <typename T>
void ArrayList<T>::clear()
{
}

template <typename T>
xi32 ArrayList<T>::indexOf(T e) 
{
    return 0;
}

template <typename T>
xi32 ArrayList<T>::lastIndexOf(T e) 
{
    return 0;
}

template <typename T>
IList<T>* ArrayList<T>::subList(xi32 frontIdx, xi32 toIdx)
{
    return NULL;
}

template <typename T>
IComparator<T>* ArrayList<T>::comparator()
{
    return NULL;
}

template <typename T>
IIterator<T>* ArrayList<T>::iterator()
{
    return NULL;
}

template <typename T>
IListIterator<T>* ArrayList<T>::listIterator()
{
    return NULL;
}

template <typename T>
IListIterator<T>* ArrayList<T>::listIterator(xi32 idx)
{
    return NULL;
}

#if 0
template <typename T>
class ArrayList: public AbstractList<T> {
private:
    T           *_array;
    xui32       _max_size;
    xui32       _size;
    Node<T>     node[100];

protected:
    boolean     inRagne(xui32 idx) {
        prsize_tf("idx: %d, _size: %d\n", idx, _size);
        if (idx >= _size)
            return uFalse;
        return uTrue;
    }

    boolean     inRagneForAdd(xui32 idx) { 
        if (idx > this->_size) 
            return uFalse;
        return uTrue;
    }
    boolean     init(xui32 size) 
    {
        this->_array = (T*)malloc(sizeof(T)*size);  /* FIXME: chagne to Allocator */
        this->_max_size = size;
        this->_size =0;
        prsize_tf("_max_size: %d, _size: %d\n", _max_size, _size);
        prsize_tf("%p\n", this);
    }

public:
    ArrayList(xui32 size) { 
    ArrayList() {  init(10); }

    boolean isEmpty() {
        return (this->_size == 0) ? uTrue : uFalse;
    }
    xen_stat_t  ensureCapacity(xui32 minCapacity) {
        prsize_tf("min: %d max: %d\n", minCapacity, this->_max_size);
        if ( minCapacity > this->_max_size ) {
            T* old_array = _array;
            xui32 newCapacity = (this->_max_size *3)/2 + 1;
            prsize_tf("\nmin: %d, new: %d\n", minCapacity, newCapacity);
            if (newCapacity < minCapacity)
                newCapacity = minCapacity;
            this->_max_size = newCapacity;
            this->_array = (T*)realloc(_array, sizeof(T)*newCapacity);
            if (_array == NULL)
                return XEN_ENOMEM;
        }
        return XEN_SUCCESS;
    }

    xui32       getMaxSize() { 
        prsize_tf("%p\n", this);
        prsize_tf(">>>> %d\n", this->_max_size); 
        return this->_max_size;
    };
    xen_stat_t  add(T o);
    xen_stat_t  add(xui32 idx, T o);
    xen_stat_t  get(xui32 idx, T* obj);
};


template <typename T>
xen_stat_t  ArrayList<T>::add(T o) {
    this->ensureCapacity(_size + 1);
    _array[_size++] = o;
    return XEN_SUCCESS;
}

template <typename T>
xen_stat_t  ArrayList<T>::add(xui32 idx, T o) {
    if (!inRagneForAdd(idx)) 
        return XEN_EOUTOFRANGE; 
    this->ensureCapacity(_size+1);
    memmove((void*)(_array + idx+1), (void*)(_array + (idx)), sizeof(T)*(_size-idx));
    _array[idx] = o;
    _size++;
    return XEN_SUCCESS;
}

template <typename T>
xen_stat_t ArrayList<T>::get(xui32 idx, T* obj) {
    if (!inRagne(idx)) 
        return XEN_EOUTOFRANGE;
    *obj = _array[idx];
    return XEN_SUCCESS;
}

template <typename T>
class Node 
{
};

#endif

#endif /* __XEN_ARRAYLIST_H__ */
