#ifndef __KAN_ICOLLECTION_H__
#define __KAN_ICOLLECTION_H__

#include "kan/KAN.h"
#include "kan/util.h"

template <typename T>
class ICollection: public IIterable<T>, public IComparable<T>{
public:
    virtual boolean     add(T e) = 0;
    virtual boolean     remove(T e) = 0;
    virtual boolean     contains(T e) = 0;

    virtual boolean     addAll(ICollection<T> *c) = 0;
    virtual boolean     removeAll(ICollection<T> *c) = 0;
    virtual boolean     retainsAll(ICollection<T> *c) = 0;
    virtual boolean     containsAll(ICollection<T> *c) = 0;

    virtual void        clear() = 0;
    virtual size_t      size() = 0;
    virtual boolean     isEmpty(T e) = 0;

    virtual IIterator<T>*   iterator() = 0;
    virtual IComparator<T>* comparator() = 0;
};

#endif  /* __KAN_ICOLLECTION_H__ */

