#ifndef __KAN_ILIST_H__
#define __KAN_ILIST_H__

template <typename T>
class IList: public ICollection<T> {
public:
    virtual boolean     add(T e) = 0;
    virtual boolean     add(xi32 idx, T e) = 0;
    virtual boolean     remove(T e) = 0;
    virtual boolean     remove(xi32 idx, T *e = NULL) = 0;
    virtual boolean     contains(T e) = 0;

    virtual T           get(xi32 idx) = 0;
    virtual T           set(xi32 idx, T e) = 0;

    virtual boolean     addAll(ICollection<T> *c) = 0;
    virtual boolean     addAll(xi32 idx, ICollection<T> *c) = 0;
    virtual boolean     removeAll(ICollection<T> *c) = 0;
    virtual boolean     retainsAll(ICollection<T> *c) = 0;
    virtual boolean     containsAll(ICollection<T> *c) = 0;

    virtual void        clear() = 0;
    virtual size_t      size() = 0;
    virtual boolean     isEmpty(T e) = 0;

    virtual xi32        indexOf(T e) = 0;
    virtual xi32        lastIndexOf(T e) = 0;
    virtual IList<T> *  subList(xi32 frontIdx, xi32 toIdx) = 0;

    virtual IComparator<T>*     comparator() = 0;
    virtual IIterator<T>*       iterator() = 0;
    virtual IListIterator<T>*   listIterator() = 0;
    virtual IListIterator<T>*   listIterator(xi32 idx) = 0;
};

#endif  /* __KAN_ILIST_H__ */
