#ifndef __KAN_IMAP_H__
#define __KAN_IMAP_H__

#include "util.h"

template <typename K, typename V>
class IMapEntry {
    virtual K getkey() = 0;
    virtual V getValue() = 0;
    virtual V setValue() = 0;
};

template <typename K, typename V>
class IMap {
public:
    typedef ISet<K>             KeySet;
    typedef IMapEntry<K,V>      MapEntry;
    typedef ISet<MapEntry>      MapEntrySet;

    virtual void                clear() = 0;
    virtual boolean             containsKey(K key) = 0;
    virtual boolean             containsValue(V val) = 0;
    virtual MapEntrySet         entrySet() = 0;
    virtual V                   get(K key) = 0;
    virtual boolean             isEmpty() = 0;
    virtual KeySet*             keySet() = 0;
    virtual V                   put(K key, V value) = 0;
    virtual void                putAll(IMap<K,V>* map) = 0;
    virtual V                   remove(K k) = 0;
    virtual int                 size() = 0;
    virtual ICollection<V>*     values() = 0;
};

#endif
