#ifndef __XEN_ARRAYLIST_H__
#define __XEN_ARRAYLIST_H__


#include "xen_util.h"


template <typename T>
class ArrayList: public Collection<T> {
private:
    T           *_array;
    xui32       _max_size;
    xui32       _size;
    Node<T>     node[100];

protected:
    boolean     inRagne(xui32 idx) {
        printf("idx: %d, _size: %d\n", idx, _size);
        if (idx >= _size)
            return uFalse;
        return uTrue;
    }
    boolean     inRagneForAdd(xui32 idx) { 
        if (idx > this->_size) 
            return uFalse;
        return uTrue;
    }
    boolean     init(xui32 size) 
    {
        this->_array = (T*)malloc(sizeof(T)*size);  /* FIXME: chagne to Allocator */
        this->_max_size = size;
        this->_size =0;
        printf("_max_size: %d, _size: %d\n", _max_size, _size);
        printf("%p\n", this);
    }

public:
    ArrayList(xui32 size) { init(size); } 
    ArrayList() {  init(10); }

    boolean isEmpty() {
        return (this->_size == 0) ? uTrue : uFalse;
    }
    xen_stat_t  ensureCapacity(xui32 minCapacity) {
        printf("min: %d max: %d\n", minCapacity, this->_max_size);
        if ( minCapacity > this->_max_size ) {
            T* old_array = _array;
            xui32 newCapacity = (this->_max_size *3)/2 + 1;
            printf("\nmin: %d, new: %d\n", minCapacity, newCapacity);
            if (newCapacity < minCapacity)
                newCapacity = minCapacity;
            this->_max_size = newCapacity;
            this->_array = (T*)realloc(_array, sizeof(T)*newCapacity);
            if (_array == NULL)
                return XEN_ENOMEM;
        }
        return XEN_SUCCESS;
    }

    xui32       getMaxSize() { 
        printf("%p\n", this);
        printf(">>>> %d\n", this->_max_size); 
        return this->_max_size;
    };
    xen_stat_t  add(T o);
    xen_stat_t  add(xui32 idx, T o);
    xen_stat_t  get(xui32 idx, T* obj);
};


template <typename T>
xen_stat_t  ArrayList<T>::add(T o) {
    this->ensureCapacity(_size + 1);
    _array[_size++] = o;
    return XEN_SUCCESS;
}

template <typename T>
xen_stat_t  ArrayList<T>::add(xui32 idx, T o) {
    if (!inRagneForAdd(idx)) 
        return XEN_EOUTOFRANGE; 
    this->ensureCapacity(_size+1);
    memmove((void*)(_array + idx+1), (void*)(_array + (idx)), sizeof(T)*(_size-idx));
    _array[idx] = o;
    _size++;
    return XEN_SUCCESS;
}

template <typename T>
xen_stat_t ArrayList<T>::get(xui32 idx, T* obj) {
    if (!inRagne(idx)) 
        return XEN_EOUTOFRANGE;
    *obj = _array[idx];
    return XEN_SUCCESS;
}

template <typename T>
class Node 
{
};


#endif /* __XEN_ARRAYLIST_H__ */
